import React from 'react';
import NumberFormat from 'react-number-format';
import PropTypes from 'prop-types';

class TableGen extends React.Component {
  constructor(props) {
    super(props);
    this.state = {};
  }

  render() {
    return React.createElement("div", {
      className: "table-responsive"
    }, React.createElement("table", {
      className: "table"
    }, React.createElement("thead", null, this.props.additionalHeader, React.createElement("tr", null, this.props.columnHeaders.map((header, index) => {
      const key = this.props.columnKeys[index];
      return React.createElement("th", {
        className: "pointer",
        key: index,
        onClick: () => {
          this.setState({
            tableSortKey: key,
            tableSortOrder: this.state.tableSortKey === key ? -this.state.tableSortOrder : 1
          });
        }
      }, header, "\xA0 \xA0", this.state.tableSortOrder === -1 && this.state.tableSortKey === key ? React.createElement("i", {
        className: "fa fa-sort-amount-asc"
      }) : React.createElement("i", {
        className: "fa fa-sort-amount-desc"
      }));
    }))), React.createElement("tbody", null, this.props.data.sort((a, b) => {
      const x = a[this.state.tableSortKey];
      const y = b[this.state.tableSortKey];

      if (x < y) {
        return 1 * this.state.tableSortOrder;
      } else {
        return -1 * this.state.tableSortOrder;
      }
    }).map((row, index) => {
      return React.createElement("tr", {
        key: index
      }, this.props.columnKeys.map((key, index) => {
        return React.createElement("td", {
          key: index
        }, Number.isInteger(row[key]) ? React.createElement(NumberFormat, {
          value: row[key],
          displayType: 'text',
          thousandSeparator: true
        }) : row[key] ? row[key].toString() : "null");
      }));
    }), this.props.data.length === 0 ? React.createElement("tr", null, React.createElement("td", {
      align: "center",
      colSpan: this.props.columnHeaders.length
    }, "No data")) : null), this.props.foot));
  }

}

TableGen.propTypes = {
  additionalHeader: PropTypes.func,
  columnHeaders: PropTypes.array.isRequired,
  columnKeys: PropTypes.array.isRequired,
  data: PropTypes.array.isRequired,
  foot: PropTypes.func
};
export default TableGen;
